'=========================================================================
'   ݁`pp̎d VB.NETTv
'-------------------------------------------------------------------------
'   [NativeWindow]Aj[VRg[̎
'-------------------------------------------------------------------------
'   쐬  :   2003/12/12
'   :   Visual Studio.NET 2003 / Windows XP Pro SP1
'=========================================================================
Imports System.Runtime.InteropServices
Imports System.ComponentModel

Public Class Animation
    Inherits Windows.Forms.NativeWindow

    Private Const WS_BORDER As Integer = &H800000
    Private Const WS_CHILD As Integer = &H40000000
    Private Const WS_OVERLAPPED As Integer = &H0&
    Private Const WS_VISIBLE As Integer = &H10000000

    Private Const WM_USER As Integer = &H400

    Private Const SWP_NOSIZE As Integer = &H1
    Private Const SWP_NOMOVE As Integer = &H2
    Private Const SWP_NOZORDER As Integer = &H4
    Private Const SWP_FRAMECHANGED As Integer = &H20
    Private Const SWP_DRAWFRAME As Integer = SWP_FRAMECHANGED
    Private Const SW_SHOW As Integer = 5
    Private Const SW_HIDE As Integer = 0

    '//====== ANIMATE CONTROL ======================================================
    Private Const ICC_ANIMATE_CLASS As Integer = &H80
    Private Const ANIMATE_CLASS As String = "SysAnimate32"

    Private Const ACS_CENTER As Integer = &H1
    Private Const ACS_TRANSPARENT As Integer = &H2
    Private Const ACS_AUTOPLAY As Integer = &H4
    Private Const ACS_TIMER As Integer = &H8        '// don't use threads... use timers

    Private Const ACM_OPEN As Integer = (WM_USER + 100)
    Private Const ACM_PLAY As Integer = (WM_USER + 101)
    Private Const ACM_STOP As Integer = (WM_USER + 102)

    Private Const ACN_START As Integer = 1
    Private Const ACN_STOP As Integer = 2

    Private _Top As Integer = 0
    Private _Left As Integer = 0
    Private _Height As Integer = 0
    Private _Width As Integer = 0

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure tagINITCOMMONCONTROLSEX
        Public dwSize As Integer
        Public dwICC As Integer
    End Structure

    <DllImport("Comctl32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Sub InitCommonControls()
    End Sub

    <DllImport("Comctl32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function InitCommonControlsEx(ByRef lpInitCommonControlsEx As tagINITCOMMONCONTROLSEX) As Integer
    End Function

    <DllImport("User32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function SetWindowPos(ByVal hwnd As Integer, ByVal hWndInsertAfter As Integer, _
                                         ByVal x As Integer, ByVal y As Integer, _
                                         ByVal cx As Integer, ByVal cy As Integer, _
                                         ByVal wFlags As Integer) As Integer
    End Function

    <DllImport("User32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function ShowWindow(ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer
    End Function

    <DllImport("User32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function SendMessage(ByVal hwnd As Integer, ByVal wMsg As Integer, _
                                        ByVal wParam As Integer, ByVal lParam As Integer) As Integer
    End Function

    <DllImport("User32.dll", CharSet:=CharSet.Ansi)> _
    Private Shared Function SendMessage(ByVal hwnd As Integer, ByVal wMsg As Integer, _
                                        ByVal wParam As Integer, ByVal lParam As String) As Integer
    End Function


    Public Sub New(ByVal parent As Windows.Forms.Form)
        CreateAnimationControl(parent.Handle)
    End Sub

    Public Sub New(ByVal parent As Windows.Forms.Control)
        CreateAnimationControl(parent.Handle)
    End Sub

    Private Sub CreateAnimationControl(ByVal parent As IntPtr)

        Dim icc As tagINITCOMMONCONTROLSEX
        Dim intRet As Integer
        Dim cp As New CreateParams

        '// Common Control ̏
        icc.dwSize = Marshal.SizeOf(icc)
        icc.dwICC = ICC_ANIMATE_CLASS
        intRet = InitCommonControlsEx(icc)
        If intRet = 0 Then InitCommonControls()

        '// Aj[VRg[̍쐬
        cp.ClassName = ANIMATE_CLASS

        cp.X = 0
        cp.Y = 0
        cp.Height = 100
        cp.Width = 300

        cp.Parent = parent
        cp.Style = WS_CHILD Or WS_VISIBLE Or ACS_CENTER Or ACS_TRANSPARENT

        Me.CreateHandle(cp)

    End Sub

    Private Sub MoveControl()
        SetWindowPos(Me.Handle.ToInt32, 0, _Left, _Top, 0, 0, SWP_NOSIZE Or SWP_NOZORDER)
    End Sub

    Private Sub ResizeControl()
        SetWindowPos(Me.Handle.ToInt32, 0, 0, 0, _Width, _Height, SWP_NOMOVE Or SWP_NOZORDER)
    End Sub

    Public Property Height() As Integer
        Get
            Return _Height
        End Get
        Set(ByVal Value As Integer)
            _Height = Value
            ResizeControl()
        End Set
    End Property

    Public Property Width() As Integer
        Get
            Return _Width
        End Get
        Set(ByVal Value As Integer)
            _Width = Value
            ResizeControl()
        End Set
    End Property

    Public Property Top() As Integer
        Get
            Return _Top
        End Get
        Set(ByVal Value As Integer)
            _Top = Value
            MoveControl()
        End Set
    End Property

    Public Property [Left]() As Integer
        Get
            Return _Left
        End Get
        Set(ByVal Value As Integer)
            _Left = Value
            MoveControl()
        End Set
    End Property

    '==========================================================
    '   Aj[Vt@C̃I[v
    '==========================================================
    Public Function Open(ByVal szName As String) As Boolean
        ShowWindow(Me.Handle.ToInt32, SW_SHOW)
        Return SendMessage(Me.Handle.ToInt32, ACM_OPEN, 0, szName)
    End Function

    '==========================================================
    '   Aj[Vt@C̃N[Y
    '==========================================================
    Public Function Close() As Boolean
        ShowWindow(Me.Handle.ToInt32, SW_HIDE)
        Return Me.Open(0)
    End Function

    '==========================================================
    '   Aj[Vt@C̍Đ
    '==========================================================
    Public Function Play(ByVal RepeatCount As Integer, ByVal StartFrame As Integer, ByVal EndFrame As Integer) As Boolean
        Return SendMessage(Me.Handle.ToInt32, ACM_PLAY, RepeatCount, MAKELONG(StartFrame, EndFrame))
    End Function

    '==========================================================
    '   Aj[Vt@C̃t[
    '==========================================================
    Public Function Seek(ByVal SeekFrame As Integer) As Boolean
        Return Play(1, SeekFrame, SeekFrame)
    End Function

    '==========================================================
    '   Aj[Vt@C̒~
    '==========================================================
    Public Function [Stop]()
        Return SendMessage(Me.Handle.ToInt32, ACM_STOP, 0, 0)
    End Function

    '==========================================================
    '   LONGl̍쐬}N
    '==========================================================
    Private Function MAKELONG(ByVal wLow As Integer, ByVal wHigh As Integer) As Integer
        MAKELONG = wLow + (wHigh << 16) '(rbgVtg .NET Framework 1.1ȍ~̂)
    End Function

    Protected Overrides Sub Finalize()
        Me.Stop()
        Me.Close()
    End Sub

End Class
